#!/usr/bin/perl
#last update:2012-06-09 change for CASAVA1.8



use warnings;
use Getopt::Long;


my $target_path;#path to target snps file
my $back_path;#path to background snps file
my $tposition = 1;#column number of target SNPs position
my $bposition = 1;#column number of target SNPs position
my $tbase  ;#column number of target called base
my $bbase  ;#column number of background called base
my $flag =1;#flag of nucleotid compare

my $prefix_dir ='extractSNP';#prefix of output directory
#hash of matching result
my %match = (
"A_A" => "2","A_C" => "0","A_G" => "0","A_T" => "0","A_K" => "0","A_M" => "2","A_R" => "2",
"A_S" => "0","A_W" => "2","A_Y" => "0","A_B" => "0","A_D" => "2","A_H" => "2","A_V" => "2",
"A_N" => "2","C_A" => "0","C_C" => "2","C_G" => "0","C_T" => "0","C_K" => "0","C_M" => "2",
"C_R" => "0","C_S" => "2","C_W" => "0","C_Y" => "2","C_B" => "2","C_D" => "0",
"C_H" => "2","C_V" => "2","C_N" => "2","G_A" => "0","G_C" => "0","G_G" => "2",
"G_T" => "0","G_K" => "2","G_M" => "0","G_R" => "2","G_S" => "2","G_W" => "0",
"G_Y" => "0","G_B" => "2","G_D" => "2","G_H" => "0","G_V" => "2","G_N" => "2",
"T_A" => "0","T_C" => "0","T_G" => "0","T_T" => "2","T_K" => "2","T_M" => "0","T_R" => "0",
"T_S" => "0","T_W" => "2","T_Y" => "2","T_B" => "2","T_D" => "2","T_H" => "2",
"T_V" => "0","T_N" => "2","K_A" => "0","K_C" => "0","K_G" => "1","K_T" => "1",
"K_K" => "2","K_M" => "0","K_R" => "1","K_S" => "1","K_W" => "1","K_Y" => "1",
"K_B" => "2","K_D" => "2","K_H" => "1","K_V" => "1","K_N" => "2","M_A" => "1",
"M_C" => "1","M_G" => "0","M_T" => "0","M_K" => "0","M_M" => "2","M_R" => "1","M_S" => "1",
"M_W" => "1","M_Y" => "1","M_B" => "1","M_D" => "1","M_H" => "2","M_V" => "2",
"M_N" => "2","R_A" => "1","R_C" => "0","R_G" => "1","R_T" => "0","R_K" => "1","R_M" => "1",
"R_R" => "2","R_S" => "1","R_W" => "1","R_Y" => "0","R_B" => "1","R_D" => "2",
"R_H" => "1","R_V" => "2","R_N" => "2","S_A" => "0","S_C" => "1","S_G" => "1",
"S_T" => "0","S_K" => "1","S_M" => "1","S_R" => "1","S_S" => "2","S_W" => "0",
"S_Y" => "1","S_B" => "2","S_D" => "1","S_H" => "1","S_V" => "2","S_N" => "2",
"W_A" => "1","W_C" => "0","W_G" => "0","W_T" => "1","W_K" => "1","W_M" => "1",
"W_R" => "1","W_S" => "0","W_W" => "2","W_Y" => "1","W_B" => "1","W_D" => "2",
"W_H" => "2","W_V" => "1","W_N" => "2","Y_A" => "0","Y_C" => "1","Y_G" => "0",
"Y_T" => "1","Y_K" => "1","Y_M" => "1","Y_R" => "0","Y_S" => "1","Y_W" => "1","Y_Y" => "2",
"Y_B" => "2","Y_D" => "1","Y_H" => "2","Y_V" => "1","Y_N" => "2","B_A" => "0",
"B_C" => "1","B_G" => "1","B_T" => "1","B_K" => "1","B_M" => "1","B_R" => "1",
"B_S" => "1","B_W" => "1","B_Y" => "1","B_B" => "2","B_D" => "1","B_H" => "1",
"B_V" => "1","B_N" => "2","D_A" => "1","D_C" => "0","D_G" => "1","D_T" => "1",
"D_K" => "1","D_M" => "1","D_R" => "1","D_S" => "1","D_W" => "1","D_Y" => "1",
"D_B" => "1","D_D" => "2","D_H" => "1","D_V" => "1","D_N" => "2","H_A" => "1",
"H_C" => "1","H_G" => "0","H_T" => "1","H_K" => "1","H_M" => "1","H_R" => "1",
"H_S" => "1","H_W" => "1","H_Y" => "1","H_B" => "1","H_D" => "1","H_H" => "2",
"H_V" => "1","H_N" => "2","V_A" => "1","V_C" => "1","V_G" => "1","V_T" => "0",
"V_K" => "1","V_M" => "1","V_R" => "1","V_S" => "1","V_W" => "1","V_Y" => "1",
"V_B" => "1","V_D" => "1","V_H" => "1","V_V" => "2","V_N" => "2","N_A" => "1",
"N_C" => "1","N_G" => "1","N_T" => "1","N_K" => "1","N_M" => "1","N_R" => "1",
"N_S" => "1","N_W" => "1","N_Y" => "1","N_B" => "1","N_D" => "1","N_H" => "1",
"N_V" => "1","N_N" => "2"
);
####help message
my $help_msg = << 'HELP';
Description: perl script to remove background SNPs and extract target-specific SNPs
Uasage: perl SNPextract.pl -t /path/to/trget_snps_file -b /path/to/background_snps_file
Options:
 -t  <file> Path to target SNPs list file.
 -b  <file> Path to background SNPs list file.
 -p1  <int> Column nummber of SNPs position in target file (defaut:1 2nd column)
 -p2  <int> Column nummber of SNPs position in background file (defaut:1 2nd column)
 -nt1 <int> Column nummber of mutated nucleotid position in target file (default:undef)
 -nt2 <int> Column nummber of mutated nucleotid position in background file (default:undef)
 -o   <stirng> Prefix of output directory (default:SNPextract)
 -h          Show this help message. 
HELP

####
####

#Input options
GetOptions('target=s' => \$target_path, 'background=s' => \$back_path, 'nt1=i' => \$tbase, 'nt2=i' => \$bbase, 
'p1=i' => \$tposition, 'p2=i' => \$bposition, 'output=s' => \$prefix_dir, 'help|?' => \$help ) or die "ERROR:Please check options.";

#Show help
if($help){
	print STDERR $help_msg;
	exit;
}
#Check essntial options
if(!defined($target_path) or !defined($back_path)){
	print STDERR "ERROR:lacking of required options.Please check options.\n";
	print STDERR $help_msg;
	exit;
}


if(!defined($tbase) or !defined($bbase)){
	print STDERR "column position of mutated nucleotid is not undefined\nOnly check SNPs postion\n";
	$flag = 0;
}



#READING target snps.txt
open(IN, "$target_path") or die "Can't open file:$target_path\n";
while(<IN>){
	$target_raw .= $_;
}
close(IN);
$target_raw =~ s/\x0D\x0A|\x0D|\x0A/\n/g;
@target_data = split(/\n/,$target_raw);
@target_data = grep(/^[^\#]/,@target_data);#remove comment line
undef $target_raw;
printf STDERR "target snps num:%s\n",$#target_data + 1;


#target SNPs list to hash
foreach (@target_data){
	my $p = (split(/\t/,$_))[$tposition];
	if(!(defined $p)){die "ERROR option:-p $tposition is invalid value\n"}
	if(defined($target_hash{$p})){
		print STDERR "SNP in position:$p is find in multiple line. Their data is merged.";
		$back_hash{$p} .= '&merged\t'. $_;
	}else{
		$target_hash{$p} = $_;
	}
	if(defined($tbase)){$target_nt{$p} = (split(/\t/,$_))[$tbase];}
}

#READING background snps.txt
open(IN, "$back_path") or die "Can't open file:$back_path\n";
while(<IN>){
	$back_raw .= $_;
}
close(IN);
$back_raw =~ s/\x0D\x0A|\x0D|\x0A/\n/g;
@back_data = split(/\n/,$back_raw);
@back_data = grep(/^[^\#]/,@back_data);#remove comment line
undef $back_raw;
printf STDERR "background snps num:%s\n",$#back_data + 1;

#background SNPs list to hash
foreach (@back_data){
	my $p = (split(/\t/,$_))[$bposition];
	if(!(defined $p)){die "ERROR option:-p $bposition is invalid value\n"}
	if(defined($back_hash{$p})){
		print STDERR "SNP in position:$p is find in multiple line. Their data is merged.";
		$back_hash{$p} .= '&merged\t'. $_;
	}else{
		$back_hash{$p} = $_;
	}
	if(defined($bbase)){$back_nt{$p} = (split(/\t/,$_))[$bbase];}
}


#SNPs check: target SNPS vs background SNPs
foreach my $pt (sort {$a <=> $b} keys %target_hash){
	if(defined($back_hash{$pt})){
		if($flag){
			my @tbases = split(//,$target_nt{$pt}) ;
			my @bbases = split(//,$back_nt{$pt});
			my $tb = join("",sort(@tbases));
			$tb = &ntconvert($tb);
			my $bb = join("",sort(@bbases));
			$bb = &ntconvert($bb);
			my $base_key = $tb . "_" .$bb;
			if(!defined $match{$base_key}){die "ERROR:$base_key,$target_nt{$pt}:$tb,$back_nt{$pt}:$bb"}
			if($match{$base_key} == 2){
				push(@perfect_match,"$target_hash{$pt}\t\@background_data\t$back_hash{$pt}");
			}elsif($match{$base_key} == 1){
				push(@partial_match,"$target_hash{$pt}\t\@background_data\t$back_hash{$pt}");
			}else{
				push(@position_match,"$target_hash{$pt}\t\@bacground_data\t$back_hash{$pt}");
			}
		}else{
			push(@position_match,"$target_hash{$pt}\t\@background_data\t$back_hash{$pt}");
		}
		
	}else{
		push(@no_match,$target_hash{$pt})
	}
}

#MAKING output directory
($day,$month) = (localtime(time))[3,4];
$month++;
$prefix_dir =sprintf("%s%02d%02d",$prefix_dir,$month,$day);
$outdir = $prefix_dir;
$num = 2;
while(-d $outdir){
	$outdir ="$prefix_dir-$num";
	$num++;
}

mkdir($outdir) or die "Can\'t make output directory:$outdir\n";
print STDERR "Output directory:$outdir\n";

#Report results
if($flag){printf STDERR ("num of perfect match: %d\n",$#perfect_match+1);}
if($flag){printf STDERR ("num of partial match: %d\n",$#partial_match+1);}
printf STDERR ("num of position match: %d\n",$#position_match+1);
printf STDERR ("num of no match: %d\n",$#no_match+1);

#OUTPUT filtered data
&output("position",\@position_match);
&output("no",\@no_match);
if($flag){
	&output("partial",\@partial_match);
	&output("perfect",\@perfect_match);
}
#######################################

#OUTPUT function
sub output{
local $" = "\n";
my($name,$data,) = @_;
open (OUT,">$outdir/"."$name"."_match.txt") or die "ERROR:Can\'t open result file about $name";
print OUT "@{$data}\n";
close OUT;
}

sub ntconvert{
my $input = $_[0];
$input =~ s/^AA$/A/i;
$input =~ s/^CC$/C/i;
$input =~ s/^GG$/G/i;
$input =~ s/^TT$/T/i;
$input =~ s/^AC$/M/i;
$input =~ s/^AG$/R/i;
$input =~ s/^AT$/W/i;
$input =~ s/^CG$/S/i;
$input =~ s/^CT$/Y/i;
$input =~ s/^GT$/K/i;
$input =~ s/^CGT$/B/i;
$input =~ s/^AGT$/D/i;
$input =~ s/^ACT$/H/i;
$input =~ s/^ACG$/V/i;
$input =~ s/^ACGT$/N/i;

return $input;
}


