#!/usr/bin/perl
#update:2011-09-05 

use warnings;
use Getopt::Long;

my $target_path = "";#path to target snps file
my $position = 1;
my $window = 500000;
my $type = ""; #column position of SNPs type
my $length = '';
my $help = 0;

###
my $help_msg = << 'HELP';
Description: Count nummber of SNPs within some interval.
Usage: perl stateSNPs.pl -t /path/to/target_SNPs_file [other_options] >output.txt
Options:
 -t <file> Path to target SNPs file.
 -p <int>  Column number of SNPs position in target SNPs file. The number of leffmost column is "0". [defaut=1]
 -d <int>  Column number of descriptions(type) in target file [default:undef]. 
 -w <int>  Window size of sammation. [default:500000]
 -h <int>  Show this help message.
HELP
####


GetOptions('target=s' => \$target_path, 'position=i' => \$position, 'window=i' => \$window, 'descriptions=i' => \$type, 'end=i' => \$length, 'help' => \$help) 
or die "ERROR:Invalid option(s). Please check options.\n";


if($help){
	print STDERR $help_msg;
	exit;
}
if(!$target_path){
	print STDERR "ERROR:Path to target file is invalid.\n\n";
	print STDERR $help_msg;
	exit;	
}
#READING target snps.txt
open(IN, "$target_path") or die "Can't open input file:$target_path\n";
while(<IN>){
	$target_raw .= $_;
}
close(IN);
$target_raw =~ s/\x0D\x0A|\x0D|\x0A/\n/g;
@target_data = split(/\n/,$target_raw);
@target_data = grep(/^[^\#]/,@target_data);#remove comment line
undef $target_raw;
printf STDERR "target snps num:%s\n",$#target_data + 1 ;


#target SNPs list to hash
#key:position of SNP
print STDERR "type:$type\n";
foreach my $raw_data(@target_data){
	my $p = (split(/\t/,$raw_data))[$position] ;
	
	if($type ne ""){
		
		$target_hash{$p} = (split(/\t/,$raw_data))[$type] ;
	}else{
		$target_hash{$p} = "all_data";
	}
}
#Check type
foreach my $posi (sort {$a <=> $b} keys %target_hash){
	$type_count{$target_hash{$posi}}++
}
foreach my $snptype (sort keys %type_count){
	print STDERR "$snptype num: $type_count{$snptype}\n";

}

#GET end of array
if($length){
	print STDERR "end of chr is \"$length\" difined in option\n";
}else{
	my @posi = sort {$a <=> $b}(keys %target_hash);
	$length = $posi[$#posi];
	print STDERR "end of chr is \"$length\" from input file\n";
}

#MAKING array of start end count

for ($i = 0; $i <= $length/$window;$i++){
	$start[$i] = $window * $i +1 ;
	$end[$i] = $window * ($i + 1);
	foreach my $snptype (sort keys %type_count){
		${$snptype}[$i] = 0; 
	}	
}

#count SNPs within window
$index = 0;
foreach my $psnp (sort {$a <=> $b} keys %target_hash){
		while($psnp > $end[$index]){
			$index++;
		}
	${$target_hash{$psnp}}[$index]++;


	#print "$psnp:$index:$end[$index]\n";
}

#output
print "start\tend";
foreach my $snptype (sort keys %type_count){
	print "\t$snptype";
}
print "\n";	
for($k = 0 ; $k <= $#start; $k++){
	print "$start[$k]\t$end[$k]";
	foreach my $snptype (sort keys %type_count){
		print "\t${$snptype}[$k]";
	}
	print "\n";
}




